10 '
20 ' NNumb.bas built by Keith Williams upon Renumber.bas from Geoff Graham.
30 '     Geoff Graham 2010 and Keith Williams 2012.
40 '
50 '   Version NNumb6 -- 20/1/2012
60 '
70 ' NNumb.bas replaces line numbers with labels in a basic program.
80 ' Labels are assigned in ascending order by destination occurance.
90 ' MMBasic 3 requires that a Goto be used before a line number after
100 ' a THEN or ELSE. A space is inserted before colons folowing line numbers.
110 '
120 Cls
130 maxlines = 1000
140 Dim lines(maxlines)
150 '
160 Maxlabels = 100
170 Dim Labels(maxlabels,3)
180 '
190 Print : Print " This program will replace line numbers with labels."
200 Print
210 Print " A GOTO will be inserted before line numbers after THEN or ELSE."
220 Print " Minimal error checking is done,programs require prior debugging."
230 Print : Print
240 Input "Program to No-Number: ", iname$
250 Open iname$ For INPUT As #1
260 Input "    Output file name: ", oname$
270 Open "NNXXX.bas" For output As #2
280 '
290 nbrlines = 0
300 Do While Not Eof(#1)
310   Line Input #1, inp$
320   lines(nbrlines) = Val(inp$)
330   nbrlines  = nbrlines  + 1
340   If nbrlines  > maxlines Then Error "Program has too many lines"
350 Loop
360 Close #1
370 Print : Print " Processing Pass 1 " : Print
380 Lcount = 0
390 Open iname$ For INPUT As #1
400 For lineindex = 0 To nbrlines - 1
410   Line Input #1, inp$
420   GoSub 630  ' process the line
430   Print #2, Left$(inp$, Len(inp$) - 3)
440   Print ".";
450 Next lineindex
460 '
470 Close #1, #2
480 Print
490 Print : Print " Finished Pass 1, processed";nbrlines;" lines" : Print
500 GoTo 3020 ' Now preproc for pas 2
510 '
520 'Keywords that use line numbers
530 'Each keyword in uppercase. The last entry an empty string (ie, "").
540 '
550 Data "GOTO","GOSUB","THEN","ELSE","SETPIN","SETTICK","OPEN","I2CEN","I2CSEN","ON",""
560 '
570 ''''''''''''''''''''''''''''''''''''''''''''
580 'subroutine
590 'process a line (in inp$) and replace all
600 'line numbers.  returns with inp$ updated
610 '
620 ''''''''''''''''''''''''''''''''''''''''''''
630 original$ = inp$
640 ptr = 1
650 'first remove the line number
660 'skip spaces
670 Do
680   GoSub 2890
690   If endstmt Then Error "No line number in: " + original$
700 Loop While ch$ = " "
710 '
720 'skip numeric digits
730 Do While ch$ >= "0" And ch$ <= "9"
740   GoSub 2890
750 If endstmt Then Error "No statement in: " + original$
760 Loop
770 '
780 'replace line number with spaces
790 inp$ = "   " + Mid$(inp$, ptr) + "   "
800 '
810 'check for each keyword, if matched replace the line number with label
820 'repeat for the same keyword until there are no more on the line
830 'then step to the next keyword and repeat
840 '
850 Restore    : n = 0
860 uinp$ = UCase$(inp$) ' convert to upper case for comparisons
870 Do
880   Read kw$
890   If kw$ = "" Then Return        'null means end of list
900   n = n + 1    : ptr = 1
910   Do
920     ptr = Instr(ptr, uinp$, kw$) 'find the keyword
930     If ptr <> 0 Then
940       GFlag = 0 ' until process THEN or ELSE
950       ptr = ptr + Len(kw$)       'step over it and process
960       On n GoSub 1320, 1320, 1290, 1290, 2560, 2730, 2210, 2560, 2400, 1150
970     EndIf
980   Loop While ptr <> 0
990 Loop
1000 '
1010 '''''''''''''''''''''''''
1020 'subroutine
1030 'process an ON statement
1040 '
1050 '''''''''''''''''''''''''
1060 '
1070 'later scans for gosub/goto will find the first
1080 'line number following the gosub/goto so we only
1090 'need to look for a comma and process the line
1100 'number after it.  Fortunatly the subroutine for
1110 'processing settick does exactly that so we just
1120 'repeatedly call it until we hit the end of the
1130 'statement
1140 '
1150 Do
1160   GoSub 2730
1170 Loop While Not endstmt
1180 Return
1190 '
1200 ''''''''''''''''''''''''''''''''''''''''''''''''''
1210 'subroutine
1220 'process a (possible) line number following a GOTO,
1230 'GOSUB, THEN or ELSE
1240 'also called by other routines that have navigated
1250 'to a possible line nbr
1260 '
1270 ''''''''''''''''''''''''''''''''''''''''''''''''''
1280 '
1290 GFlag = 1 ' Flag set for GOTO addition
1300 '
1310 'first skip any spaces
1320 Do
1330   GoSub 2890
1340   If endstmt Then Return
1350 Loop  While ch$ = " "
1360 '
1370 ' then get the number (if there)
1380 nbrstr$ = "" : Qcolon = 0
1390 Do While ch$ >= "0" And ch$ <= "9"
1400   nbrstr$ = nbrstr$ + ch$
1410   GoSub 2890
1420 ' Fix to Renumber ****
1430   If endstmt Then
1440     If Mid$(inp$, ptr, 1) = ":" Then
1450       ptr = ptr + 1 : Qcolon = 1
1460     EndIf
1470     Exit
1480   EndIf
1490 Loop
1500 If Val(nbrstr$) = 0 Then Return  ' no line number
1510 '
1520 'got a line number, find it in the table
1530 nbr = Val(nbrstr$)
1540 For i = 0 To nbrlines - 1
1550   If lines(i) = nbr Then 1610
1560 Next i
1570 Print : Print "Cannot find line number " + nbrstr$ + " in: " + original$ : Return
1580 '
1590 'splice the new temp label (Labc) into the line
1600 '
1610  oldnposn = (ptr - Len(nbrstr$)) - 2 : oldptr = ptr
1620  cx = 4 - Len(nbrstr$) 'difference in label length
1630 '
1640 If Gflag = 0 Then ' check not a THEN or ELSE ?
1650 '
1660   Lab$ = "Labc"
1670   ptr = oldnposn + 4
1680   nposn = oldnposn
1690 '
1700 Else
1710 '
1720   Lab$ = "GoTo Labc"
1730   ptr = oldnposn + 9
1740   nposn = oldnposn + 5
1750   cx = cx + 5
1760 '
1770 EndIf
1780 '
1790 If Qcolon = 1 Then ' need extra space post colon ?
1800   Lab$ = Lab$ + " "
1810   ptr = ptr + 1
1820   cx = cx + 1
1830 EndIf
1840 '
1850 inp$ = Left$(inp$,oldnposn) + Lab$ + Mid$(inp$,oldptr - 1 )
1860 '
1870 uinp$ = UCase$(inp$) ' also to upper case for keyword searching
1880 '
1890 ' Build Array # 1 to contain data for second pass
1900 '
1910 labels(lcount,1) = Lineindex+1 ' Line Number "
1920 labels(lcount,2) = nposn       ' Offset to label
1930 labels(lcount,3) = i           ' label address
1940 '
1950 ' Fix saved offsets due to line expansion
1960 '
1970 If cx <> 0 Then              ' was there an offset change?
1980 '
1990   For p = 1 To lcount - 1    ' current size of array without last
2000     q = labels(p,1)          ' get the line number
2010     If q = lineindex+1 Then  ' same as current line # ?
2020       r = labels(p,2)        ' get the saved offset
2030       If r > nposn Then      ' past present offset?
2040         labels(p,2) = r + cx ' adjust offset
2050       EndIf
2060     EndIf
2070   Next p
2080 '
2090 EndIf
2100 '
2110 Lcount = Lcount + 1          ' Increment Array 1 index
2120 Return
2130 '
2140 ''''''''''''''''''''''''''''''''''''''''
2150 '
2160 ' subroutine
2170 ' process OPEN statement
2180 ' must pass a colon plus 2 commas to #
2190 '
2200 ''''''''''''''''''''''''''''''''''''''''
2210  Do While ch$ <> ","
2220   GoSub 2890
2230   If endstmt Then
2240     If Mid$(inp$, ptr, 1) = ":" Then
2250       ptr = ptr + 1
2260     Else
2270       Return
2280     EndIf
2290   EndIf
2300  Loop
2310  GoTo 2730 ' look for next comma and #
2320 '
2330 '''''''''''''''''''''''''''''''
2340 ' subroutine
2350 ' process I2CSEN statement
2360 ' must pass 3 commas to first #
2370 '
2380 '''''''''''''''''''''''''''''''
2390 '
2400 Do While ch$ <> "," ' initial comma ?
2410   GoSub 2890
2420   If endstmt Then Return
2430 Loop
2440 '
2450 GoSub 2560 'look for 2 more commas then first line #
2460  If endstmt Then Return ' was dumped out?
2470 GoTo 2730  'look for another comma and second #
2480 '
2490 '''''''''''''''''''''''''''''''''''
2500 'subroutine
2510 'process a setpin or I2Cen statement
2520 '
2530 '''''''''''''''''''''''''''''''''''
2540 '
2550 'search for the first comma
2560 ch$ = "x" 'remove previous flag
2570 Do While ch$ <> ","
2580   GoSub 2890
2590   If endstmt Then Return
2600 Loop
2610 '
2620 'fall through to the settick processing which looks for a comma
2630 'and then processes the following text as a line number
2640 '
2650 '''''''''''''''''''''''''''''''''''''''
2660 'subroutine
2670 'process the settick statement
2680 'also used for setpin and on statements
2690 '
2700 '''''''''''''''''''''''''''''''''''''''
2710 '
2720 'search for the comma
2730 ch$ = "x"
2740 Do While ch$ <> ","
2750   GoSub 2890
2760   If endstmt Then Return
2770 Loop
2780 GoTo 1320 ' get and process the line number
2790 '
2800 ''''''''''''''''''''''''''''''''''''''''''''''''''''''
2810 'subroutine
2820 'returns the character in ch$ from string inp$ @ posn. ptr
2830 'ptr is incremented
2840 'returns with endstmt = true if reached the end of the
2850 'line or a new statement
2860 '
2870 ''''''''''''''''''''''''''''''''''''''''''''''''''''''
2880 '
2890 endstmt = -1 : ch$ = Chr$(1)
2900 If ptr >= Len(inp$) Then Return  'end of the line
2910 If Mid$(inp$, ptr,1) = ":" Then Return ' new statement
2920 ch$ = Mid$(inp$, ptr, 1)
2930 endstmt = 0
2940 ptr = ptr + 1
2950 Return
2960 '
2970 ' Major additions to Renumber to make Nonumber
2980 ' **********************************************
2990 '
3000 ' Build Array #2 for destinations
3010 '
3020 lines(0) = 0
3030 lines(1) = 0
3040 For i = 0 To Lcount - 1
3050   lines(i) = labels(i,3)
3060 Next i
3070 '
3080 lines(Lcount) = 0 ' Mark end of list
3090 '
3100 ' Sort Destinations into assending  order
3110 '
3120 s=1
3130 While s = 1
3140   s = 0
3150   For x = 0 To lcount - 2
3160     If lines(x) > lines(x + 1) Then
3170       t = lines(x)
3180       lines(x) = lines(x + 1)
3190       lines(x + 1 ) = t
3200       s = 1
3210     EndIf
3220   Next
3230 Wend
3240 '
3250 ' Remove duplicate destinations
3260 '
3270 x = 0
3280 Do While lines(x) <> 0 And x < lcount
3290   Do While lines(x) = lines(x + 1 )
3300     For p = x To Lcount
3310       lines(p) = lines(p + 1)
3320     Next p
3330   Loop
3340   x = x + 1
3350 Loop
3360 '
3370 destn = x
3380 '
3390 ' Place new label numbers into Array #1
3400 '
3410 For x = 0 To destn - 1
3420  For i = 0 To lcount - 1
3430   If lines(x) = labels(i,3) Then labels(i,3) = x
3440  Next i
3450 Next x
3460 '
3470 ' Do Pass 2 process--Place Labels
3480 ' *******************************
3490 '
3500 Print : Print " Starting Pass 2 " : Print
3510 '
3520 Open "NNXXX.bas" For input As #1
3530 Open oname$ For output As #2
3540 '
3550 i = 0 : j = 0 'start of tables
3560 '
3570 For lineindex = 1 To nbrlines
3580  Line Input #1, inp$
3590  GoSub 3790 ' add the labels
3600  Print #2, inp$
3610  Print "*";
3620 Next Lineindex
3630 '
3640 Close #1,#2
3650 '
3660 Kill "NNXXX.bas"
3670 '
3680 Print : Print : Print " Finished Pass 2" : Print
3690 '
3700 Print " Placed " + Format$(j,"% 3.0f") + " Incidence Labels into Program '" + oname$ + "'"
3710 Print " Placed " + Format$(i,"% 3.0f") + " Destination Labels"
3720 End
3730 '
3740 ' Sub. place labels into line
3750 ' ***************************
3760 '
3770 ' Process all Incidence Labels for this line
3780 '
3790 If Lcount <> 0 Then
3800 If j < Lcount Then ' Lcount = # of Incidence
3810   Do While Lineindex = Labels(j,1) 'test for line number
3820     Labl$ = "L" + Format$((labels(j,3) + 1),"%03.0f")
3830     offst = labels(j,2)
3840     inp$ = Left$(inp$,offst) + Labl$ + Mid$(inp$,offst + 5)
3850     j = j + 1
3860   Loop
3870 EndIf
3880 '
3890 ' Now any Destination Label for this line?
3900 '
3910     If lineindex = lines(i) + 1 And i < destn Then
3920       Labl$ = "L" + Format$(i + 1,"%03.0f") + ":"
3930       inp$ = labl$ + Mid$(inp$,3)
3940       i = i + 1
3950     EndIf
3960 EndIf
3970 '
3980 Return